@Filename: Putchar.s
@Part: ADuC702x.
@Created: 20/04/2004
@Updated: 28/06/2005
@Author: Eckart Hartmann.
@This file is in beta sampling.

.include        "ADuC7020.equ"
.ARM

@ putchar==========UART put character.
@ C Function prototype: int putchar(int iTx);
@iTx:{}
@ Description of Function: Writes iTx to the UART for transmission.
@ User interface:
@   Put value to send in iTx.
@   Call putchar. Will wait untill buffer not full then output iTx.
@   Returns iTx in r0 always.
@ Robustness:
@   UART must be configured before writing data.
@   Waits as long as UART is full.
@ Side effects: Corrupts r1 and r3.

.GLOBAL putchar
putchar:
        mov     r3,#0xff0000              @r3 = Z_BASE;
        orr     r3,r3,#0xff000000
PcLoop1:ldr     r1,[r3,#COMSTA0_OFFSET]   @while(COMSTA.6);
        ands    r1,r1,#0x040
        beq     PcLoop1
        str     r0,[r3,#COMTX_OFFSET]     @COMTX = iTx;
PcLoop2:ldr     r1,[r3,#COMSTA0_OFFSET]   @while(COMSTA.6);
        ands    r1,r1,#0x040
        beq     PcLoop2
        cmp     r0,#0x0A                  @Compare r0 with '\n'
        moveq   r1,#0x0D                  @ Move 0D into r1 
        streq   r1,[r3,#COMTX_OFFSET]     @ COMTX = 0x0D;
        bx      lr                        @return r0.

